"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
exports.IndexStorage = void 0;
var path_1 = require("path");
var lodash_1 = require("lodash");
var ConnectionPool_1 = require("./ConnectionPool");
var IndexStorage = /** @class */ (function () {
    function IndexStorage(cacheDir) {
        this.cacheDir = cacheDir;
    }
    IndexStorage.prototype.db = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, ConnectionPool_1.ConnectionPool.getDatabase(path_1.join(this.cacheDir, 'index.sqlite3'))];
            });
        });
    };
    IndexStorage.prototype.put = function (hash, size) {
        return __awaiter(this, void 0, void 0, function () {
            var db;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.db()];
                    case 1:
                        db = _a.sent();
                        return [4 /*yield*/, db.run('REPLACE INTO items (hash, size, accessTime) VALUES (?, ?, ?)', hash, size, Date.now())];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    IndexStorage.prototype.getGarbageItems = function (maxSize) {
        return __awaiter(this, void 0, void 0, function () {
            var db, _a, avgSize, sumSize, reserveFactor, garbageSize, approxGarbageItemsCount, garbageItems, exactGarbageItems, i, sum;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.db()];
                    case 1:
                        db = _b.sent();
                        return [4 /*yield*/, db.get('SELECT AVG(size) AS avgSize, SUM(size) AS sumSize FROM items')];
                    case 2:
                        _a = _b.sent(), avgSize = _a.avgSize, sumSize = _a.sumSize;
                        reserveFactor = 1.5;
                        garbageSize = sumSize - maxSize;
                        if (garbageSize <= 0) {
                            return [2 /*return*/, []];
                        }
                        approxGarbageItemsCount = Math.round((reserveFactor * garbageSize) / avgSize);
                        return [4 /*yield*/, db.all('SELECT hash, size FROM items ORDER BY accessTime ASC LIMIT ?', approxGarbageItemsCount)];
                    case 3:
                        garbageItems = _b.sent();
                        exactGarbageItems = [];
                        for (i = 0, sum = 0; i < garbageItems.length && sum <= garbageSize; i++) {
                            exactGarbageItems.push(garbageItems[i].hash);
                            sum += garbageItems[i].size;
                        }
                        return [2 /*return*/, exactGarbageItems];
                }
            });
        });
    };
    IndexStorage.prototype.remove = function (hashes) {
        return __awaiter(this, void 0, void 0, function () {
            var db, questionMarks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.db()];
                    case 1:
                        db = _a.sent();
                        questionMarks = lodash_1.times(hashes.length, lodash_1.constant('?')).join(', ');
                        return [4 /*yield*/, db.run.apply(db, __spreadArrays(["DELETE FROM items WHERE hash IN(" + questionMarks + ")"], hashes))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return IndexStorage;
}());
exports.IndexStorage = IndexStorage;
