/// <reference types="node" />
import { Track } from 'kalama-api';
import { EventEmitter } from 'events';
export declare type TracksList = Array<Track>;
export declare type FileName = string;
export declare type Hash = string;
export interface CacheItem {
    id: string;
    file: FileName | null;
}
export interface PlaylistCacheOptions {
    storageDirectory: string;
    concurrency: number;
    maxSize: number;
}
export declare class PlaylistCache extends EventEmitter {
    private readonly tracks;
    private readonly options;
    private retryQueue;
    private descriptors;
    private tracksById;
    private storage;
    private hashesById;
    constructor(tracks: TracksList, options: PlaylistCacheOptions);
    private indexTracksById;
    private createHashList;
    private createCacheDescriptorsList;
    private reportCachedItems;
    private fetchTrack;
    private saveToIndex;
    private commit;
    private getTrackHash;
    private hashToFile;
    private getTrackPath;
    private getCachedItem;
    getCachedItems(): Promise<{
        [id: string]: CacheItem;
    }>;
    fetch(): Promise<void>;
    cleanup(): Promise<void>;
}
