"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.PlaylistCache = void 0;
var download = require("download");
var events_1 = require("events");
var md5 = require("md5");
var assert = require("assert");
var path_1 = require("path");
var fs_1 = require("q-io/fs");
var lodash_1 = require("lodash");
var IndexStorage_1 = require("./IndexStorage");
var PlaylistCache = /** @class */ (function (_super) {
    __extends(PlaylistCache, _super);
    function PlaylistCache(tracks, options) {
        var _this = _super.call(this) || this;
        _this.tracks = tracks;
        _this.options = options;
        _this.retryQueue = [];
        _this.hashesById = _this.createHashList();
        _this.descriptors = _this.createCacheDescriptorsList();
        _this.tracksById = _this.indexTracksById();
        _this.storage = new IndexStorage_1.IndexStorage(_this.options.storageDirectory);
        return _this;
    }
    PlaylistCache.prototype.indexTracksById = function () {
        return lodash_1.keyBy(this.tracks, 'id');
    };
    PlaylistCache.prototype.createHashList = function () {
        var _this = this;
        return lodash_1.fromPairs(this.tracks.map(function (track) { return [track.id, _this.getTrackHash(track)]; }));
    };
    PlaylistCache.prototype.createCacheDescriptorsList = function () {
        var _this = this;
        return lodash_1.keyBy(this.tracks.map(function (t) {
            var path = _this.getTrackPath(t);
            return {
                id: t.id,
                tempFile: path + ".download",
                file: path + ".mp3"
            };
        }), 'id');
    };
    PlaylistCache.prototype.reportCachedItems = function (items) {
        this.emit('change', items);
    };
    PlaylistCache.prototype.fetchTrack = function (track) {
        return __awaiter(this, void 0, void 0, function () {
            var id, url, _a, storage, _b, hash, cached, _c, tempFile, file;
            var _d, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        id = track.id, url = track.url;
                        _a = this, storage = _a.storage, _b = id, hash = _a.hashesById[_b];
                        return [4 /*yield*/, this.getCachedItem(track)];
                    case 1:
                        cached = _f.sent();
                        if (!cached.file) return [3 /*break*/, 3];
                        this.reportCachedItems((_d = {}, _d[id] = cached, _d));
                        return [4 /*yield*/, this.saveToIndex(track)];
                    case 2:
                        _f.sent();
                        return [2 /*return*/];
                    case 3:
                        _c = this.descriptors[id], tempFile = _c.tempFile, file = _c.file;
                        return [4 /*yield*/, download(url, path_1.dirname(tempFile), {
                                filename: path_1.basename(tempFile)
                            })];
                    case 4:
                        _f.sent();
                        return [4 /*yield*/, this.commit(track)];
                    case 5:
                        _f.sent();
                        return [4 /*yield*/, this.saveToIndex(track)];
                    case 6:
                        _f.sent();
                        this.reportCachedItems((_e = {}, _e[id] = { file: file, id: id }, _e));
                        return [2 /*return*/];
                }
            });
        });
    };
    PlaylistCache.prototype.saveToIndex = function (track) {
        return __awaiter(this, void 0, void 0, function () {
            var id, _a, _b, hash, _c, tempFile, file, size;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        id = track.id;
                        _a = this.hashesById, _b = id, hash = _a[_b];
                        _c = this.descriptors[id], tempFile = _c.tempFile, file = _c.file;
                        return [4 /*yield*/, fs_1.stat(file)];
                    case 1:
                        size = (_d.sent()).size;
                        return [4 /*yield*/, this.storage.put(hash, size)];
                    case 2:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PlaylistCache.prototype.commit = function (track) {
        return __awaiter(this, void 0, void 0, function () {
            var desc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        desc = this.descriptors[track.id];
                        return [4 /*yield*/, fs_1.move(desc.tempFile, desc.file)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PlaylistCache.prototype.getTrackHash = function (track) {
        assert(track.id);
        // TODO: cache for better performance
        return md5(track.id);
    };
    PlaylistCache.prototype.hashToFile = function (h) {
        var part0 = h.substr(0, 2);
        var part1 = h.substr(2, 2);
        return path_1.join(this.options.storageDirectory, part0, part1, h);
    };
    PlaylistCache.prototype.getTrackPath = function (track) {
        var h = this.hashesById[track.id];
        var part0 = h.substr(0, 2);
        var part1 = h.substr(2, 2);
        return path_1.join(this.options.storageDirectory, part0, part1, h);
    };
    PlaylistCache.prototype.getCachedItem = function (track) {
        return __awaiter(this, void 0, void 0, function () {
            var desc, itemExists;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        desc = this.descriptors[track.id];
                        return [4 /*yield*/, fs_1.exists(desc.file)];
                    case 1:
                        itemExists = _a.sent();
                        return [2 /*return*/, { id: track.id, file: itemExists ? desc.file : null }];
                }
            });
        });
    };
    PlaylistCache.prototype.getCachedItems = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tracks, results;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        tracks = this.tracks;
                        return [4 /*yield*/, Promise.all(tracks.map(function (t) { return _this.getCachedItem(t); }))];
                    case 1:
                        results = _a.sent();
                        return [2 /*return*/, lodash_1.keyBy(results, 'id')];
                }
            });
        });
    };
    PlaylistCache.prototype.fetch = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, tracks, concurrency, cachedItems, i;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this, tracks = _a.tracks, concurrency = _a.options.concurrency;
                        return [4 /*yield*/, this.getCachedItems()];
                    case 1:
                        cachedItems = _b.sent();
                        this.reportCachedItems(cachedItems);
                        i = 0;
                        _b.label = 2;
                    case 2:
                        if (!(i < tracks.length)) return [3 /*break*/, 5];
                        return [4 /*yield*/, Promise.all(tracks
                                .slice(i, i + concurrency)
                                .map(function (track) { return _this.fetchTrack(track); }))];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        i += concurrency;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    PlaylistCache.prototype.cleanup = function () {
        return __awaiter(this, void 0, void 0, function () {
            var maxSize, garbageItems, deletedItems, i, hash, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        maxSize = this.options.maxSize;
                        return [4 /*yield*/, this.storage.getGarbageItems(maxSize)];
                    case 1:
                        garbageItems = _a.sent();
                        deletedItems = [];
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < garbageItems.length)) return [3 /*break*/, 7];
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        hash = garbageItems[i];
                        return [4 /*yield*/, fs_1.remove(this.hashToFile(hash) + ".mp3")];
                    case 4:
                        _a.sent();
                        deletedItems.push(hash);
                        return [3 /*break*/, 6];
                    case 5:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 6];
                    case 6:
                        i++;
                        return [3 /*break*/, 2];
                    case 7:
                        this.storage.remove(deletedItems);
                        return [2 /*return*/];
                }
            });
        });
    };
    return PlaylistCache;
}(events_1.EventEmitter));
exports.PlaylistCache = PlaylistCache;
